jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

--hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
quality = GetQualityLevel4()
hifi = quality > 2 -- GetQualityLevel returns 1,2,or 3
ultra = quality > 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

function ByQuality4(low,med,high,ultra)
	if quality < 2 then return low
	elseif quality <3 then return med
	elseif quality <4 then return high
	else return ultra end
end

skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]
--if trackWidth < 9.5 then
--	trackWidth = 9.5
--end

if trackWidth > 7.5 then hideRoof = true end

print("trackWidth:"..trackWidth)

ispuzzle = skinvars.colorcount>1
fullsteep = jumping or skinvars.prefersteep or (not ispuzzle)

Profile("ignore this first one in the log")

--particleBaseSize = .14
particleBaseSize = .2
--if ultra and not jumping then particleBaseSize = .09 end

LoadSounds{
	hit="ring.wav",
	hitgrey="hurt.wav",
	trickfail="hurt.wav",
	matchsmall="fz_clear.wav",
	matchmedium="fz_goal.wav",
	matchlarge="fz_clear.wav",
	matchhuge="falconpunch.wav",
	overfillwarning="overfill.wav"
}

--[[SetScene{
	glowpasses = ifhifi(4,0),
	glowspread = ifhifi(0.5,0),
	radialblur_strength = 0;--ifhifi(.5,0),
--	radialblur_strength = fif(jumping,2,0),
	watertype = 2,
	water = false, --only use the water cubes in wakeboard mode
	--watertint = {r=255,g=255,b=255,a=11},
	watertint = {r=255,g=255,b=255,a=234},
	--watertint_highway = true,
	--watertexture = "WaterCubesBlue_BlackTop_WhiteLowerTier.png",--waterBW.png",
	watertexture = "White.png",
	widewater = true, --sets water to 16.25 width
	towropes = false,--use the tow ropes if jumping
	airdebris_count = ifhifi(fif(jumping, 80000, 100000),1000),
	airdebris_density = ifhifi(10,2),
	airdebris_particlesize = particleBaseSize, -- fif(jumping, 0.12, 0.09),
	airdebris_fieldsize = 300,
	airdebris_layer = 13,
	--airdebris_texture = "particle_whitestar.png",
	useblackgrid=false,
	crease_strength=ifhifi(-47,0),
	closecam_near=.05,
	closecam_far=22, --bringing this in closer than the default (50) improves the ship's shadow quality
	--twistmode={curvescaler=1, steepscaler=.1} -- note: "cork" is the same as {curvescaler=1, steepscaler=1} and "cork_flatish" is the same as {curvescaler=1, steepscaler=.4}

	minimap_colormode = fif((skinvars.colorcount >= 3), "white", "track")
}
]]-- STADIUM---------------------

SetScene{
	glowpasses = 0, --rend tout lumineux
	--glowspread = ifhifi(0.5,0),
	radialblur_strength = 0;--ifhifi(.5,0),
	--dynamicFOV = 1,
	--watertype = 2,
	water = false, --only use the water cubes in wakeboard mode
	--watertint = {r=255,g=255,b=255,a=11},
	--watertint = {r=255,g=255,b=255,a=234},
	--watertint_highway = true,
	--watertexture = "WaterCubesBlue_BlackTop_WhiteLowerTier.png",--waterBW.png",
	--watertexture = "White.png",
	--widewater = true, --sets water to 16.25 width
	towropes = false,--use the tow ropes if jumping
	airdebris_count = ifhifi(5000,1000),
	airdebris_density = ifhifi(10,2),
	airdebris_particlesize = particleBaseSize, -- fif(jumping, 0.12, 0.09),
	airdebris_fieldsize = 300,
	airdebris_layer = 13,
	--airdebris_texture = "particle_whitestar.png",
	useblackgrid=false,
	crease_strength=ifhifi(-47,0),
	closecam_near=.05,
	closecam_far=22, --bringing this in closer than the default (50) improves the ship's shadow quality
	--twistmode={curvescaler=1, steepscaler=.1} -- note: "cork" is the same as {curvescaler=1, steepscaler=1} and "cork_flatish" is the same as {curvescaler=1, steepscaler=.4}

	minimap_colormode = "white",
}

Profile("SetScene")

SetBlockFlashes{
	texture="hit2.jpg",
	--sizescaler = fif(hifi, 1.0, 0.3)
	sizescaler_missed = fif(hifi, .2, .1),
	sizescaler = fif(hifi, .6, 0.35)
}

if hifi and not jumping then
	lightR = CreateLight{
		railoffset = 0,
		type = "directional",
		transform = {pos={0,0,0},rot={39,244,0}},
		shadows={type=fif(hifi,"hard","none"), strength=0.3},
	}

	lightL = CreateLight{
		railoffset = 0,
		type = "directional",
		transform = {pos={0,0,0},rot={39,116,0}},
		shadows={type=fif(hifi,"hard","none"), strength=0.3},
	}
elseif hifi and ispuzzle then
	CreateLight{
		type= "directional",
		railoffset = -1,
		range = 10,
		intensity = 1,
		transform = {
			position={0,2,0}, rotation={.4,346.2,0}
		},
		color={255,255,255}
	}
end

Profile("SetBlockFlashes and CreateLights")

--[[
spikeMesh = BuildMesh{
				recalculateNormalsEveryFrame=true,
				meshes={"wallmorph_baseline.obj", "wallmorph0.obj", "wallmorph1.obj", "wallmorph2.obj", "wallmorph3.obj", "wallmorph4.obj"}
			}

ballMesh = BuildMesh{
				recalculateNormalsEveryFrame=true,
				meshes={"ballmorph_baseline.obj", "ballmorph0.obj", "ballmorph1.obj", "ballmorph2.obj", "ballmorph3.obj", "ballmorph4.obj"}
			}

--towerMesh = BuildMesh{
--				recalculateNormalsEveryFrame=true,
--				meshes={"towermorph_baseline.obj", "towermorph0.obj", "towermorph1.obj", "towermorph2.obj", "towermorph3.obj", "towermorph4.obj"}
--			}

squareMesh = BuildMesh{
				recalculateNormalsEveryFrame=true,
				meshes={"squaremorph_baseline.obj", "squaremorph0.obj", "squaremorph1.obj", "squaremorph2.obj", "squaremorph3.obj", "squaremorph4.obj"}
			}
]]--

Profile("Build traffic meshes")
--[[
function Update(dt, trackLocation, playerStrafe, playerJumpHeight, intensity)
	--intensity goes from 0.2 to 1.1
	--strength goes from 0 to 1
	local rFactor = math.max(0,playerStrafe/3.0);
	local lFactor = math.max(0,playerStrafe/-3.0);

	--the fractal corridor has a lights evenly spaced
	--strobe the light intensity to sync
	local corridorFactor = math.fmod(trackLocation,4.6)
	corridorFactor = math.abs(corridorFactor-2.3)
	corridorFactor = 0.85 + 0.15*corridorFactor

	--lights should head towards xrot 90 at center so shadows line up

	if hifi then
		UpdateLight{light=lightR, transform={rot={39+(1.0-rFactor)*51, 244, 0}}, intensity = corridorFactor*(.2 + rFactor*.9), shadows={type=fif(hifi,"hard","none"),strength=0.25+corridorFactor*rFactor*0.1}}
		UpdateLight{light=lightL, transform={rot={39+(1.0-lFactor)*51, 116, 0}}, intensity = corridorFactor*(.2 + lFactor*.9), shadows={type=fif(hifi,"hard","none"),strength=0.25+corridorFactor*lFactor*0.1}}
	end

	local fft = GetSpectrum();--GetSpectrum();
	local morphweights = {
						3.5 * (fft[1]+fft[2]+fft[3]),
						1.5 * (fft[4]+fft[5]+fft[6]),
						1.5 * (fft[7]+fft[8]+fft[9]),
						1.5 * (fft[10]+fft[11]+fft[12]),
						1.5 * (fft[13]+fft[14]+fft[15]+fft[16])
					}
	UpdateMeshMorphWeights{mesh=spikeMesh, weights=morphweights}
	UpdateMeshMorphWeights{mesh=ballMesh, weights=morphweights}
	--UpdateMeshMorphWeights{mesh=towerMesh, weights=morphweights}
	local morphweightsreversed = {morphweights[5], morphweights[4], morphweights[3], morphweights[2], morphweights[1]}
	UpdateMeshMorphWeights{mesh=squareMesh, weights=morphweightsreversed}

	if shipMaterial then
		--local enginePower = 3 + 20*intensity
		local enginePower = 0 + 99*intensity
		UpdateShaderSettings{material=shipMaterial, shadersettings={_GlowScaler=enginePower}}
		--UpdateMaterial{material=shipMaterial, shadersettings={_GlowScaler=enginePower}, texturesettings={tiling={intensity,intensity},offset={0,0} }}
	end
end
]]--

chainspanMaterial = BuildMaterial{
	renderqueue = 3033,
	shader="VertexColorUnlitTintedAdd",
	texture="White.png"
}

SetPuzzleGraphics{
	usesublayerclone = false,
	puzzlematchmaterial = {shader="Unlit/Transparent",texture="tileMatchingBars.png",aniso=9},
	puzzleflyupmaterial = {shader="VertexColorUnlitTintedAddFlyup",texture="tileMatchingBars.png"},
	puzzlematerial = {shader="VertexColorUnlitTintedAlpha",texture="tilesSquare.png",texturewrap="clamp",aniso=9, usemipmaps="false",shadercolors={_Color={255,255,255,255}}}
}

Profile("Build chainspan mat and SetPuzzleGraphics")

blockColors = blockColors or {}
puzzleTrackColors = puzzleTrackColors or {}
if skinvars.colorcount < 5 then
	--blockColors ={
	--    {r=0, g=66, b=240},
	--    {r=15, g=215, b=255},
	--    {r=255, g=189, b=15},
	--	{r=227, g=38, b=0}
	--}
	blockColors ={
		{r=126, g=0, b=255},
	    {r=0, g=66, b=240},
	    --{r=0, g=184, b=0},
	    {r=255, g=189, b=15},
		{r=227, g=38, b=0}
	}
	puzzleTrackColors = {} -- deepcopy(blockColors)
	table.insert(puzzleTrackColors, {r=0, g=66, b=240})
	table.insert(puzzleTrackColors, {r=0, g=66, b=240})

	table.insert(puzzleTrackColors, {r=2, g=2, b=2})
	table.insert(puzzleTrackColors, {r=222, g=222, b=222})
	table.insert(puzzleTrackColors, {r=255, g=189, b=15})
	table.insert(puzzleTrackColors, {r=22, g=22, b=22})
	table.insert(puzzleTrackColors, {r=2, g=2, b=2})
	table.insert(puzzleTrackColors, {r=255, g=189, b=15})

	table.insert(puzzleTrackColors, {r=222, g=222, b=222})
	table.insert(puzzleTrackColors, {r=222, g=222, b=222})
	table.insert(puzzleTrackColors, {r=227, g=38, b=0})
	table.insert(puzzleTrackColors, {r=22, g=22, b=22})
	table.insert(puzzleTrackColors, {r=5, g=5, b=5})
	table.insert(puzzleTrackColors, {r=227, g=38, b=0})

else
	--blockColors={
	--    {r=214, g=0, b=254},
	--    {r=0, g=176, b=255},
	--    {r=0, g=184, b=0},
	--    {r=255, g=255, b=0},
	--	{r=255, g=0, b=0}
	--}
	blockColors ={
		{r=126, g=0, b=255},--purple
	    {r=0, g=66, b=240},--blue
	    --{r=15, g=215, b=255},--light blue
	    {r=0, g=184, b=0},--green
	    {r=255, g=189, b=15},--yelloworange
		{r=227, g=38, b=0}--red
	}
	puzzleTrackColors = deepcopy(blockColors)
	puzzleTrackColors[1] = {r=0, g=66, b=240}
end
SetBlockColors(blockColors)

trackPalette = GetAlbumArtPalette{mincount=3, maxcount=5}
maxGreyDeviation = 0
for i=1,#trackPalette do
	local c = trackPalette[i]
	local avg = (c.r + c.g + c.b) / 3.0
	local biggestGreyDev = math.max(math.abs(c.b-avg), math.max(math.abs(c.r-avg), math.abs(c.g-avg)))
	maxGreyDeviation = math.max(maxGreyDeviation, biggestGreyDev)
end

if skinvars.colorcount < 3 then
	SetTrackColors(trackPalette)
else
	SetTrackColors(puzzleTrackColors)
end

forceStaticColorOntoMonoBlocks = false
overrideHighwayColor = {245,245,0}
overrideGreyColor = {158,168,180}
if maxGreyDeviation < .075 then -- this track is too colorless (maybe from greyscale album art). Force color onto the mono blocks, but leave the track grey(ish)
	if skinvars.colorcount < 3 then
		OverrideTrackColorForDynamicBlockColors(overrideHighwayColor)
		forceStaticColorOntoMonoBlocks = true
	end
end

Profile("Set block and track colors")


SetPlayer{
	--showsurfer = false,
	--showboard = false,
	cameramode = "third",
--	cameramode_air = "first",--"first_jumptrickthird", --start in first, go to third for jumps and tricks

	camfirst={
		pos={0,1.84,-0.8},
		rot={20,0,0}},
	camthird={
		pos={0,2,-0.5},
		rot={30,0,0},
		strafefactorFar = .75,
		pos2={0,5,-4},
		rot2={30,0,0},
		strafefactorFar = 1,
		transitionspeed = 1,
		puzzleoffset=-0.65,
		puzzleoffset2=-1.5},
	vehicle={ --livecoding not supported here
		min_hover_height= 0.23,
		max_hover_height = 0.8,
		use_water_rooster = false,
		smooth_tilting = true,
		smooth_tilting_speed = 10,
		smooth_tilting_max_offset = -20,
		pos={x=0,y=-.2,z=-.1},
		mesh="ninjamono.obj",
		shader="VertexColorUnlitTinted",
		layer = 14,
		renderqueue = 2000,
		shadercolors={
			_Color = {250,250,250}},
		texture="ninjaMono.png",
		scale = {x=1.4,y=1.4,z=1.4},
		thrusters = {crossSectionShape={{-.35,-.35,0},{-.5,0,0},{-.35,.35,0},{0,.5,0},{.35,.35,0},{.5,0,0},{.35,-.35,0}},
					perShapeNodeColorScalers={.5,1,1,1,1,1,.5},
					--shader="VertexColorUnlitTinted",
					shader="VertexColorUnlitTintedAddSmooth",
					layer = 14,
					renderqueue = 3999,
					colorscaler = 2,
					extrusions=22,
					stretch=-0.1191,
					updateseconds = 0.1,
					instances={
						-- {pos={.068,.2,-.8},rot={0,0,0},scale={1,1,1}},
						{pos={-.15,0.1,-.6},rot={0,0,0},scale={.4,.4,1}},
						{pos={.3,0.1,-.6},rot={0,0,0},scale={.4,.4,1}},
					}
					}
		}
}

Profile("setplayer and setvehicle")


--[[ Stadium ---------------------
if ultra then
	SetSkybox{
		--skyscreen = fif(jumping, "TheGridSkyBlue.shader", "thegridSky_pulsing.shader"),
		skyscreen = fif(jumping, "Skyscreen/TheGridSkyBlue", "Skyscreen/TheGridSky"),
		skyscreenlayer = 18 --13 for normal layer -- 11 for both
	}
elseif hifi then
	SetSkybox{
		skyscreen = fif(jumping, "Skyscreen/TheGridSkyBlue_min", "Skyscreen/TheGridSky_min"),
		skyscreenlayer = 18 --13 for normal layer -- 11 for both
	}
else
	SetSkybox{
		color = {colorsource="highway", staticalpha=0, minscaler=.3,maxscaler=.5},
		custom={
			_FrontTex = "Front.png",
			_BackTex = "Back.png",
			_LeftTex = "Left.png",
			_RightTex = "Right.png",
			_UpTex = "Top.png",
			_DownTex = "Bottom.png"
		}
	}
end
]]-- --------------------- /Stadium

SetSkybox{ --this shows how to set up a skybox. There's also a dynamic sky system that's used by the audiosprint skin. It could be used here too.
	skysphere="skyline.jpg",
	color={r=255,g=255,b=255,a=0}
}

SetBlockColors{
	    {r=255, g=255, b=0}
	}

Profile("setskybox")



SetBlocks{
	maxvisiblecount = 200, -- fif(skinvars.minvisibleblocks, math.max(200, skinvars.minvisibleblocks), 200),
	powerups={--override the following objects in case the mod uses them
		ghost={
			mesh = "DoubleLozengeXL.obj",
			shader = "VertexColorUnlitTinted",
			texture = "White.png"
		},
		powerpellet={
			mesh = squareMesh,
			shader = fif(hifi,"MatCap/Vertex/Textured Lit Double Mult", "MatCap/Vertex/PlainBright"),
			shadersettings = fif(hifi, {_Brightness=4.0}, {_Brightness=5}),
			textures = {_MainTex="White.png", _MatCap="matcapchrome.jpg"},
			scale = {2.7,2.7,2.7},
			reflect = true,
			shadercolors = {_Color="highway"}
		},
		whiteblock={
			mesh = "slantblock.obj",
			shader = fif(hifi, "Specular", "VertexColorUnlitTintedAddDepthWrite"),
			texture = "slantblock.png"},
		x2={
			mesh = "x2.obj",
			shader = fif(hifi, "Specular", "VertexColorUnlitTintedAddDepthWrite"),
			texture = "White.png"},
		x3={
			mesh = "x3.obj",
			shader = fif(hifi, "Specular", "VertexColorUnlitTintedAddDepthWrite"),
			texture = "White.png"},
		x4={
			mesh = "x4.obj",
			shader = fif(hifi, "Specular", "VertexColorUnlitTintedAddDepthWrite"),
			texture = "White.png"},
		x5={
			mesh = "x5.obj",
			shader = fif(hifi, "Specular", "VertexColorUnlitTintedAddDepthWrite"),
			texture = "White.png"}
		},
	chainspans={
		material = chainspanMaterial
		--renderqueue = 3033,
		--shader = "VertexColorUnlitTintedAdd"
	}
}

if math.random(2)==1 then
SetBlocks{
	colorblocks={
		mesh = "DoubleLozenge.obj",
		shader = fif(ispuzzle, "VertexColorUnlitTinted", "RimLight"),
		texture = fif(ispuzzle,"White.png","DoubleLozenge.png"),
		--shader = "RimLight",
		height = 0,
		float_on_water = false,
		--reflect=true,
		scale = {1,1,1}
	}
}
else
SetBlocks{
	colorblocks={
			mesh = "coin.obj",
			--meshmorph = "coin2.obj",
			--meshmorphtype = "intensity",
			--meshmorphsmoothspeed = 4,
			shader = "VertexColorUnlitTinted",
			texture = "coin.png",
		    height = 0,
		    float_on_water = false,
		    scale = {1,1,.75}
		}
	}
end

if math.random(2)==1 then
SetBlocks{
	greyblocks={
			mesh = "goomba1.obj",
			meshmorph = "goomba1.obj",
			meshmorphtype = "intensity",
			meshmorphsmoothspeed = 4,
			shader = "VertexColorUnlitTinted",
			texture = "goomba.png"
		}
}
else
SetBlocks{
	greyblocks={
			mesh = "doublespike.obj",
			meshmorph = "goomba1.obj",
			meshmorphtype = "intensity",
			meshmorphsmoothspeed = 4,
			shader = "RimLight",
			texture = "doublespike.png"
		}
	}
end

if not ispuzzle then
SetTrackColors{ --enter any number of colors here. The track will use the first ones on less intense sections and interpolate all the way to the last one on the most intense sections of the track
	{r=255, g=255, b=0}
}

	SetBlockColors{
	    {r=255, g=255, b=0}
	}
end
Profile("setblocks")


extraWidth = trackWidth - 5


--[[ Stadium ---------------------
SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	--texture="Classic_OnBlack.png",
	texture = ByQuality4("Classic_OnBlack_256.png", "Classic_OnBlack_512.png", "Classic_OnBlack_1024.png", "Classic_OnBlack_1024.png"),
	shader=fif(jumping, "VertexColorUnlitTintedAddDouble", "VertexColorUnlitTintedAddDouble"),
	layer = 13, -- on layer13, these objects won't be part of the glow effect
	size=fif(jumping, 28.5, 14+extraWidth),--math.max(25, trackWidth*2), --22
	offset=fif(jumping, {0,11,0}, {0,-2.75,0}),
	percentringed=.2,--ifhifi(2,.01),-- .2,
	--airtexture="Classic_OnBlack_bottomfade.png",
	airtexture=ByQuality4("Classic_OnBlack_bottomfade_256.png","Classic_OnBlack_bottomfade_512.png","Classic_OnBlack_bottomfade_1024.png","Classic_OnBlack_bottomfade_1024.png"),
	airshader="VertexColorUnlitTintedAddDouble",
	airsize=13
}
]]-- --------------------- /Stadium





SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	texture=fif(math.random(2)==2, "ring_tiki.png", "ring_loop.png"),
	--texture="Classic_OnBlack",
	shader="VertexColorUnlitTintedAlpha",
	layer = 13, -- on layer13, these objects won't be part of the glow effect
	size=trackWidth*2, --22
	percentringed=.08,--ifhifi(2,.01),-- .2,
	airtexture="Bits.png",
	airshader="VertexColorUnlitTintedAddSmoothNoDepth",
	airsize=16
}

Profile("setrings")

--wakeHeight = 2
--if jumping then wakeHeight=2 else wakeHeight = 0 end
--SetWake{ --setup the spray coming from the two pulling "boats"
--	height = wakeHeight,
--	fallrate = 0.95,
--	shader = "VertexColorUnlitTinted",
--	layer = 13, -- looks better not rendered in background when water surface is not type 2
--	bottomcolor = {r=0,g=0,b=100},
--	topcolor = "highway"
--}

wakeHeight = 2
--[[
if jumping then wakeHeight=2 else wakeHeight = 0 end
SetWake{ --setup the spray coming from the two pulling "boats"
	height = wakeHeight,
	fallrate = .999,
	shader = "VertexColorUnlitTintedAddSmooth",
	layer = 13, -- looks better not rendered in background when water surface is not type 2
	bottomcolor = {r=15,g=115,b=199},
	topcolor = {r=0,g=0,b=0}
}
]]--  -- STADIUUUUM

if math.random(2)==1 then
	CreateObject{
		name="EndCookie",
		tracknode="end",
		gameobject={
			transform={pos={0,0,0}},
			mesh="Goalring.obj",
			--shader="RimLightHatched",
			shader="VertexColorUnlitTintedAlpha",
			shadercolors={
				_Color={50,50,0},
				_RimColor={255,255,1}
			}
		}
	}

else
	CreateObject{
		name="EndCookie",
		tracknode="end",
		gameobject={
			transform={pos={0,0,22},scale={scaletype="intensity",min={1,1,1},max={1,2,1}}},
			mesh="castle.obj",
			shader="VertexColorUnlitTintedAlpha",
			shadercolors={
				_Color={255,255,255}
			},
			texture="castle.png"
		}
	}
	CreateObject{
		name="Pole",
		tracknode="end",
		gameobject={
			transform={pos={0,0,22},scale={scaletype="intensity",min={1,1,1},max={1,2,1}}},
			mesh="pole1.obj",
			meshmorph = "pole2.obj",
			meshmorphtype = "intensitysmoothfall",
			shader="VertexColorUnlitTinted",
			shadercolors={
				_Color={255,255,255}
			},
			texture="pole.png"
		}
	}
end





--[[
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="BuildingCloneMe",
	gameobject={
		pos={x=0,y=0,z=0},
		--mesh="skyscraper42.obj",
		mesh="skyscraper_withbase_sqrt.obj",
		--shader="VertexColorUnlitTintedAlpha",
		--shader=fif(true, "Diffuse", "VertexColorUnlitTinted"),
		shader="UnlitTex",
		diffuseinair = fif(jumping, true, false),
		shadercolors={
			--_Color={r=255,g=255,b=255}
			--_Color="highwaysmooth"
			--_Color = {colorsource="highway", scaletype="intensity", minscaler=6, maxscaler=6}
			_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
		},
		texture="black.png",
		--texture="Grey25.png",
		--texture="skyscraper.png",
		scale = {x=1,y=1,z=1}
	}
} ]]--

CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="Beebot",
	gameobject={
		pos={x=400,y=-400,z=400},
		--mesh="skyscraper42.obj",
		mesh="Beebot.obj",
		--shader="VertexColorUnlitTintedAlpha",
	shader="ProximityEmissionVertexColor",
		diffuseinair = false,
		shadercolors={
			--_Color={r=255,g=255,b=255}
			--_Color="highwaysmooth"
			--_Color = {colorsource="highway", scaletype="intensity", minscaler=6, maxscaler=6}
			_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
		},
		texture="White.png",
		--texture="skyscraper.png",
		scale = {x=3,y=3,z=3}
	}
}

track = GetTrack()--get the track data from the game engine

Profile("blah")

if buildingNodes == nil then
	buildingNodes = {} --the track is made of nodes, each one with a position and rotation. This table will hold the indices of track nods that should have a skyscraper rendered at them (with some offset)
	offsets = {}
	buildingNodesToo = {}
	offsetsToo = {}
	for i=1,#track do
		if i%80==0 then
			buildingNodes[#buildingNodes+1] = i
			local xOffset = 150 + 1650*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			offsets[#offsets+1] = {xOffset,-100,0}
		end
	end

	--[[BatchRenderEveryFrame{prefabName="BuildingCloneMe", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
		locations=buildingNodes,
		rotateWithTrack=false,
		maxShown=100,
		maxDistanceShown=20000,
		offsets=offsets,
		collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
		testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
	}]]--
						
	BatchRenderEveryFrame{prefabName="Beebot", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
		locations=buildingNodes,
		rotateWithTrack=false,
		maxShown=5000,
		maxDistanceShown=200,
		offsets=offsets,
		collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
		testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
	}
end

Profile("place buildings")

--[[
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="pointedpostCloneMe",
	gameobject={
		pos={x=0,y=0,z=0},
		--mesh="skyscraper42.obj",
		mesh="pointedpost.obj",
		--shader="VertexColorUnlitTintedAlpha",
		shader=fif(true, "Diffuse", "VertexColorUnlitTinted"),
		diffuseinair = true,
		shadercolors={
			--_Color={r=255,g=255,b=255}
			--_Color="highwaysmooth"
			--_Color = {colorsource="highway", scaletype="intensity", minscaler=6, maxscaler=6}
			_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
		},
		texture="black.png",
		--texture="skyscraper.png",
		scale = {x=1,y=1,z=1}
	}
}

if ppNodes == nil then
	ppNodes = {} --the track is made of nodes, each one with a position and rotation. This table will hold the indices of track nods that should have a skyscraper rendered at them (with some offset)
	ppoffsets = {}

	for i=1,#track do
		local tracknode = track[i]
		if not tracknode["funkyrot"] then --if this isn't in a corkscrew or loop
			if ((i%35) == 0) then
				ppNodes[#ppNodes+1] = i
				ppoffsets[#ppoffsets+1] = {0,0,0}
			end
		end
	end

	BatchRenderEveryFrame{prefabName="pointedpostCloneMe", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
							locations=ppNodes,
                    		rotateWithTrack=false,
                    		maxShown=100,
                    		maxDistanceShown=4000,
							offsets=offsets,
							collisionLayer = -1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
							testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
						}
end
--]]

--RAILS. rails are the bulk of the graphics in audiosurf. Each one is a 2D shape extruded down the length of the track.

if not jumping then
	local laneDividers = skinvars["lanedividers"]
	for i=1,#laneDividers do
		CreateRail{ -- lane line
			positionOffset={
				x=laneDividers[i],
				y=0.02},
			crossSectionShape={
				{x=-.04,y=0},
				{x=.04,y=0}},
			perShapeNodeColorScalers={
				1,
				1},
			colorMode="none",
			color = {r=255,g=255,b=255},
			flatten=false,
			--nodeskip = 2,
			wrapnodeshape = false,
			shader="VertexColorUnlitTinted"
		}
	end
	
	
--[[
	local shoulderLines = skinvars["shoulderlines"]
	for i=1,#shoulderLines do
		CreateRail{ -- lane line
			positionOffset={
				x=shoulderLines[i],
				y=0.02},
			crossSectionShape={
				{x=-.1,y=0},
				{x=.1,y=0}},
			perShapeNodeColorScalers={
				1,
				1},
			colorMode="highway",
			color = {r=255,g=255,b=255},
			flatten=false,
			--nodeskip = 2,
			wrapnodeshape = false,
			shader="VertexColorUnlitTintedQuadruple"
		}
		CreateRail{ -- lane line
			positionOffset={
				x=shoulderLines[i],
				y=0.04},
			crossSectionShape={
				{x=-.04,y=0},
				{x=.04,y=0}},
			perShapeNodeColorScalers={
				1,
				1},
			colorMode="highway",
			color = {r=255,g=255,b=255},
			flatten=false,
			--nodeskip = 2,
			wrapnodeshape = false,
			shader="VertexColorUnlitTintedDouble"
		}
	end
	]]--
end

Profile("track lines")

function CompareIntensityDESC(a,b)
	return a.intensity > b.intensity
end

function CompareOrigIndexASC(a,b)
	return a.origindex < b.origindex
end
--[[
if not jumping then
	--build the ceilings that tunnel in the track (like sprite tunnel rings)
	for i=1,#track do
		local tnode = track[i]
		tnode.origindex = i
		tnode.maybetunnel = false
		tnode.istunnel = false
		tnode.tunnelstrength = 0
		track[i] = tnode
	end
	table.sort(track, CompareIntensityDESC)
	for i=1, (#track * .2) do -- top 20% of nodes (by intensity) are tunnels
		track[i].maybetunnel = true
	end
	table.sort(track, CompareOrigIndexASC) -- return to original order

	local i = 1
	local span = 0
	while i < # track do
	--for i=1,#track do
		if span <= 0 then
			if track[i].maybetunnel then
				span = 0
				for j=i,#track do
					if track[j].maybetunnel then
						span = span + 1
					else
						break
					end
				end

				if span < 6 then span = 0 end
			end
		end

		if span > 0 then
			track[i].istunnel = true
			span = span - 1
		end

		i = i + 1
	end

	for i=1, #track do
		if track[i].istunnel then
			local iter = i
			for j=i+1, #track do
				iter = iter + 1
				if not track[j].istunnel then
					break
				end
			end
			local tunnelLength = (iter-1) - i
			iter = i
			for j=i, (i+tunnelLength) do
				track[j].tunnelstrength = 1
				iter = iter + 1
			end

			i = iter
		end
	end

	local cssLeft = {}
	local cssRight = {}
	for i=1, #track do
		local tstr = track[i].tunnelstrength
		local points = {
			{-6+(4.5*tstr), 5.5+(3.5*tstr)},
			{-6+(1.5*tstr), 5.5+(2.5*tstr)},
			{-6, 5.5},
		}
		cssLeft[#cssLeft+1] = points

		local rpoints = deepcopy(points)
		for j=1,#rpoints do
			local p = rpoints[j]
			p[1] = -p[1]
			rpoints[j] = p
		end
		cssRight[#cssRight+1] = rpoints
	end

	Profile("tunnel setup")

	if not hideRoof then
		CreateRail{--LEFT retractable tunnel roof
			positionOffset={
				x=-extraWidth,
				y=0},
			crossSectionShape={
					{x=-6.5,y=2.5},
					{x=-6.5,y=5.5},
					{x=-4.5,y=2.5}
				},
			crossSectionShapeList=cssLeft,
			colorMode="highway",
			color = {r=0,g=0,b=0},
			flatten=false,
			wrapnodeshape = true,
			layer=13,
			--texture="cliffRails.png",
			fullfuture = false,--ifhifi(true,false),
			shadowcaster = false,
			shadowreceiver = false,
			--stretch = 1,
			--calculatenormals = true,
			shader="Diffuse" --This shader will work as a skyscreen (rendered to a quad), but works better when it gets depth information from world-space geometry like this rail
			--skyScreen_FixedTrackOffset = {extraWidth,-5.53,0}
		}

		Profile("left tunnel rail creation")

		CreateRail{--Right retractable tunnel roof
			positionOffset={
				x=extraWidth,
				y=0},
			crossSectionShape={
					{x=-6.5,y=2.5},
					{x=-6.5,y=5.5},
					{x=-4.5,y=2.5}
				},
			crossSectionShapeList=cssRight,
			colorMode="highway",
			color = {r=0,g=0,b=0},
			flatten=false,
			wrapnodeshape = true,
			layer=13,
			--texture="cliffRails.png",
			fullfuture = false,--ifhifi(true,false),
			shadowcaster = false,
			shadowreceiver = false,
			--stretch = 1,
			--calculatenormals = true,
			shader="Diffuse" --This shader will work as a skyscreen (rendered to a quad), but works better when it gets depth information from world-space geometry like this rail
			--skyScreen_FixedTrackOffset = {extraWidth,-5.53,0}
		}
	end

	Profile("right tunnel rail creation")

	if ultra then
		CreateRail{--LEFT road surface fractal tunnel raymarching depth hinter.
			positionOffset={
				x=-extraWidth,
				y=0},
			crossSectionShape={
				{x=-7.7,y=0.71},
				{x=-4.5,y=0.71},
				{x=-4.5,y=-0.14},
				{x=-7.7,y=-0.14}
				},
			colorMode="trackposition",
			color = {r=255,g=255,b=255},
			flatten=false,
			wrapnodeshape = true,
			layer=13,
			--texture="cliffRails.png",
			fullfuture = false,--ifhifi(true,false),
			shadowcaster = false,
			shadowreceiver = false,
			--stretch = 1,
			--calculatenormals = true,
			shader="Skyscreen/Manifold5_road",--manifold5_road.shader", --This shader will work as a skyscreen (rendered to a quad), but works better when it gets depth information from world-space geometry like this rail
			--skyScreen_FixedTrackOffset = {extraWidth,-5.53,0}
			skyScreen_FixedTrackOffset = {extraWidth,-5.89,0}
		}

		CreateRail{--RIGHT road surface fractal tunnel raymarching depth hinter.
			positionOffset={
				x=extraWidth,
				y=0},
			crossSectionShape={
				{x=4.5,y=0.71},
				{x=7.7,y=0.71},
				{x=7.7,y=-0.14},
				{x=4.5,y=-0.14}
				},
			colorMode="trackposition",
			color = {r=255,g=255,b=255},
			flatten=false,
			wrapnodeshape = true,
			layer=13,
			--texture="cliffRails.png",
			fullfuture = false,--ifhifi(true,false),
			shadowcaster = false,
			shadowreceiver = false,
			--stretch = 1,
			--calculatenormals = true,
			shader="Skyscreen/Manifold5_road", --manifold5_road.shader", --This shader will work as a skyscreen (rendered to a quad), but works better when it gets depth information from world-space geometry like this rail
			skyScreen_FixedTrackOffset = {-extraWidth,-5.89,0}
		}
	else
		CreateRail{--LEFT road surface fractal tunnel raymarching depth hinter.
			positionOffset={
				x=-extraWidth,
				y=0},
			crossSectionShape={
				{x=-7.7,y=0.35},
				{x=-4.5,y=0.35},
				{x=-4.5,y=-0.5},
				{x=-7.7,y=-0.5}
				},
			colorMode="highway",
			--alphafromintensity = true,
			texturetracklength = 4.6,
			texturemirroreddowntrack = false,
			--color = {r=127,g=127,b=127},
			flatten=false,
			wrapnodeshape = true,
			layer=13,
			textures={_MainTex="roadsideUnlit.png", _IntensityTex="roadsideGlow.png"},
			shadersettings={baseIntensity=0.49, intensityScaler=2.1},
			shadercolors={_Color={160,160,160,255}},
			textureMode = "repeataround",
			fullfuture = false,--ifhifi(true,false),
			shadowcaster = false,
			shadowreceiver = false,
			usemipmaps = false,
			--stretch = 1,
			--calculatenormals = true,
			allowfullmaterialoptions = true,
			shader="VertexColorUnlitTintedIntensityTex"
		}

		CreateRail{--RIGHT road surface fractal tunnel raymarching depth hinter.
			positionOffset={
				x=extraWidth,
				y=0},
			crossSectionShape={
				{x=4.5,y=0.35},
				{x=7.7,y=0.35},
				{x=7.7,y=-0.5},
				{x=4.5,y=-0.5}
				},
			colorMode="highway",
			--alphafromintensity = true,
			texturetracklength = 4.6,
			texturemirroreddowntrack = false,
			--color = {r=127,g=127,b=127},
			flatten=false,
			wrapnodeshape = true,
			layer=13,
			allowfullmaterialoptions = true,
			textures={_MainTex="roadsideUnlit.png", _IntensityTex="roadsideGlow.png"},
			shadersettings={baseIntensity=0.49, intensityScaler=2.1},
			shadercolors={_Color={160,160,160,255}},
			textureMode = "repeataroundreverse",
			fullfuture = false,--ifhifi(true,false),
			shadowcaster = false,
			shadowreceiver = false,
			usemipmaps = false,
			--stretch = 1,
			--calculatenormals = true,
			shader="VertexColorUnlitTintedIntensityTex"
		}
	end

	if hifi then

		local manifoldshadersettings = fif(ultra, {DETAIL=0.014, fullDetailDistance=6, detailFalloff=.4,distantDetail=.04}, {DETAIL=0.03, fullDetailDistance=7, detailFalloff=.4,distantDetail=.1});

		CreateRail{--LEFT WALL fractal tunnel raymarching depth hinter.
			positionOffset={
				x=-extraWidth,
				y=0},
			crossSectionShape={
				{x=-6.5,y=2.5},
				{x=-6.5,y=5.5},
				{x=-4.5,y=5.5},
				{x=-4.5,y=2.5}
				},
			colorMode="trackposition",
			color = {r=255,g=255,b=255},
			flatten=false,
			wrapnodeshape = true,
			layer=13,
			--texture="cliffRails.png",
			fullfuture = false,--ifhifi(true,false),
			shadowcaster = false,
			shadowreceiver = false,
			allowfullmaterialoptions = true,
			--shadersettings={finnesse = .3},
			--stretch = 1,
			--calculatenormals = true,
			shader="Skyscreen/Manifold5",--Manifold5.shader", --This shader will work as a skyscreen (rendered to a quad), but works better when it gets depth information from world-space geometry like this rail
			shadersettings = manifoldshadersettings,
			skyScreen_FixedTrackOffset = {extraWidth,-4.0,0}
			--skyScreen_FixedTrackOffset = {extraWidth,-5.54,0}
		}

		CreateRail{--RIGHT WALL fractal tunnel raymarching depth hinter.
			positionOffset={
				x=extraWidth,
				y=0},
			crossSectionShape={
				{x=4.5,y=2.5},
				{x=4.5,y=5.5},
				{x=6.5,y=5.5},
				{x=6.5,y=2.5}
				},
			colorMode="trackposition",
			color = {r=255,g=255,b=255},
			flatten=false,
			wrapnodeshape = true,
			layer=13,
			--texture="cliffRails.png",
			fullfuture = false,--ifhifi(true,false),
			shadowcaster = false,
			shadowreceiver = false,
			allowfullmaterialoptions = true,
			--shadersettings={finnesse = .3},
			--stretch = 1,
			--calculatenormals = true,
			shader="Skyscreen/Manifold5",--Manifold5.shader", --This shader will work as a skyscreen (rendered to a quad), but works better when it gets depth information from world-space geometry like this rail
			shadersettings = manifoldshadersettings,
			skyScreen_FixedTrackOffset = {-extraWidth,-4.0,0}
			--skyScreen_FixedTrackOffset = {-extraWidth,-5.54,0}
		}
	else
		--non-hifi texture imposters for raymarch shaders

		CreateRail{--LEFT WALL fractal tunnel raymarching depth hinter.
			positionOffset={
				x=-extraWidth,
				y=0},
			crossSectionShape={
				{x=-6.5,y=2.5},
				{x=-6.5,y=5.5},
				{x=-4.5,y=5.5},
				{x=-4.5,y=2.5}
				},
			colorMode="highway",
			texturemirroreddowntrack = true,
			texturetracklength = 3,--since mirroring is used, this will be rounded to an integer greater than 0
			texturewrap = "clamp",
			flatten=false,
			wrapnodeshape = true,
			layer=13,
			allowfullmaterialoptions = true,
			textures={_MainTex="sidewall1.png", _IntensityTex="sidewall1GlowNeon.png", _MainTexTwo="sidewall2.png", _IntensityTexTwo="sidewall2GlowNeon.png"},
			shadersettings={baseIntensity=0.49, intensityScaler=4},
			shadercolors={_Color={255,255,255,255}},
			textureMode = "repeataround",
			--texture="cliffRails.png",
			fullfuture = false,--ifhifi(true,false),
			shadowcaster = false,
			shadowreceiver = false,
			usemipmaps = false,
			--stretch = 1,
			--calculatenormals = true,
			shader="VertexColorUnlitTintedIntensityTexDuo"
		}

		CreateRail{--RIGHT WALL fractal tunnel raymarching depth hinter.
			positionOffset={
				x=extraWidth,
				y=0},
			crossSectionShape={
				{x=4.5,y=2.5},
				{x=4.5,y=5.5},
				{x=6.5,y=5.5},
				{x=6.5,y=2.5}
				},
			colorMode="highway",
			texturemirroreddowntrack = true,
			texturetracklength = 3,--since mirroring is used, this will be rounded to an integer greater than 0
			texturewrap = "clamp",
			flatten=false,
			wrapnodeshape = true,
			layer=13,
			allowfullmaterialoptions = true,
			textures={_MainTex="sidewall1.png", _IntensityTex="sidewall1GlowNeon.png", _MainTexTwo="sidewall2.png", _IntensityTexTwo="sidewall2GlowNeon.png"},
			shadersettings={baseIntensity=0.49, intensityScaler=4},
			shadercolors={_Color={255,255,255,255}},
			textureMode = "repeataroundreverse",
			fullfuture = false,--ifhifi(true,false),
			shadowcaster = false,
			shadowreceiver = false,
			usemipmaps = false,
			--stretch = 1,
			--calculatenormals = true,
			shader="VertexColorUnlitTintedIntensityTexDuo"
		}
	end

		
	Profile("manifold rails")
else
	local floormarcheroffsetX = 0
	if not jumping then
		floormarcheroffsetX = (trackWidth + 1) - 11.4
	end

	if hifi then
		CreateRail{--RIGHT WALL fractal tunnel raymarching depth hinter.
			positionOffset={
				x=floormarcheroffsetX,
				y=0},
			crossSectionShape={
				{x=11.4,y=0.54},
				{x=15.91,y=3.2},
				{x=22.08,y=4.68},
				{x=22.08,y=-1.1},
				{x=11.4,y=-1.1}
				},
			crossSectionShapeList={ --overrides crossSectionShape
				{{x=11.4,y=0.54,z=0},
				{x=15.91,y=3.2,z=0},
				{x=22.08,y=4.68,z=0},
				{x=22.08,y=-1.1,z=0},
				{x=11.4,y=-1.1,z=0}},

				{{x=11.4,y=0.54,z=0},
				{x=15.91,y=3.2,z=0},
				{x=22.08,y=4.68,z=0},
				{x=22.08,y=-1.1,z=0},
				{x=11.4,y=-1.1,z=0}},

				{{x=11.4,y=0.54,z=0},
				{x=14.45,y=3.274,z=0},
				{x=22.08,y=4.68,z=0},
				{x=22.08,y=-1.1,z=0},
				{x=11.4,y=-1.1,z=0}},

				{{x=11.4,y=0.54,z=0},
				{x=15.91,y=3.2,z=0},
				{x=22.08,y=4.68,z=0},
				{x=22.08,y=-1.1,z=0},
				{x=11.4,y=-1.1,z=0}}
				},
			colorMode="trackposition",
			color = {r=255,g=255,b=255},
			flatten=false,
			wrapnodeshape = true,
			layer=13,
			--texture="cliffRails.png",
			fullfuture = false,--ifhifi(true,false),
			shadowcaster = false,
			shadowreceiver = false,
			--stretch = 1,
			--calculatenormals = true,
			shader="Skyscreen/Manifold5_wakeboard3",--Manifold5_wakeboard3.shader", --This shader will work as a skyscreen (rendered to a quad), but works better when it gets depth information from world-space geometry like this rail
			skyScreen_FixedTrackOffset = {-31.97 - floormarcheroffsetX,1.38,0}
		}

		CreateRail{--LEFT WALL fractal tunnel raymarching depth hinter.
			positionOffset={
				x=-floormarcheroffsetX,
				y=0},
			crossSectionShape={
				{x=-28,y=10.4},
				{x=-15.7,y=6},
				{x=-11.4,y=2.64},
				{x=-11.4,y=-2.64},
				{x=-15.7,y=-6}
				},
			crossSectionShapeList={ --overrides crossSectionShape
				{{x=-11.4,y=-1.1,z=0},
				{x=-22.08,y=-1.1,z=0},
				{x=-22.08,y=4.68,z=0},
				{x=-15.91,y=3.2,z=0},
				{x=-11.4,y=0.54,z=0}},

				{{x=-11.4,y=-1.1,z=0},
				{x=-22.08,y=-1.1,z=0},
				{x=-22.08,y=4.68,z=0},
				{x=-15.91,y=3.2,z=0},
				{x=-11.4,y=0.54,z=0}},

				{{x=-11.4,y=-1.1,z=0},
				{x=-22.08,y=-1.1,z=0},
				{x=-22.08,y=4.68,z=0},
				{x=-14.45,y=3.274,z=0},
				{x=-11.4,y=0.54,z=0}},

				{{x=-11.4,y=-1.1,z=0},
				{x=-22.08,y=-1.1,z=0},
				{x=-22.08,y=4.68,z=0},
				{x=-15.91,y=3.2,z=0},
				{x=-11.4,y=0.54,z=0}}
				},
			colorMode="trackposition",
			color = {r=255,g=255,b=255},
			flatten=false,
			wrapnodeshape = true,
			layer=13,
			--texture="cliffRails.png",
			fullfuture = false,--ifhifi(true,false),
			shadowcaster = false,
			shadowreceiver = false,
			--stretch = 1,
			--calculatenormals = true,
			shader="Skyscreen/Manifold5_wakeboard3",--Manifold5_wakeboard3.shader", --This shader will work as a skyscreen (rendered to a quad), but works better when it gets depth information from world-space geometry like this rail
			skyScreen_FixedTrackOffset = {31.97 + floormarcheroffsetX,1.38,0}
		}

		CreateRail{--RIGHT WALL fractal tunnel raymarching depth hinter.
			positionOffset={
				x=0,
				y=0},
			crossSectionShape={
				{x=11.4,y=22.568},
				{x=14,y=22.568},
				{x=16.45,y=20.574},
				{x=14,y=18},
				{x=11.4,y=18}
				},
			colorMode="trackposition",
			color = {r=255,g=255,b=255},
			flatten=false,
			wrapnodeshape = true,
			layer=13,
			--texture="cliffRails.png",
			fullfuture = false,--ifhifi(true,false),
			shadowcaster = false,
			shadowreceiver = false,
			--stretch = 1,
			--calculatenormals = true,
			shader="Skyscreen/Manifold5_wakeboard3TpRail",--wakeboard3TpRail.shader", --This shader will work as a skyscreen (rendered to a quad), but works better when it gets depth information from world-space geometry like this rail
			shadercolors={_PrimaryColor="highway"},
			skyScreen_FixedTrackOffset = {-4.47,-20.32,0}
		}

		CreateRail{--LEFT WALL fractal tunnel raymarching depth hinter.
			positionOffset={
				x=0,
				y=0},
			crossSectionShape={
				{x=-11.4,y=18},
				{x=-14,y=18},
				{x=-16.45,y=20.574},
				{x=-14,y=22.568},
				{x=-11.4,y=22.568}
				},
	--		crossSectionShape={
	--			{x=-11.4,y=18},
	--			{x=-16.45,y=18},
	--			{x=-16.45,y=25.8},
	--			{x=-11.4,y=25.8}
	--			},
			colorMode="trackposition",
			color = {r=255,g=255,b=255},
			flatten=false,
			wrapnodeshape = true,
			layer=13,
			--texture="cliffRails.png",
			fullfuture = false,--ifhifi(true,false),
			shadowcaster = false,
			shadowreceiver = false,
			--stretch = 1,
			--calculatenormals = true,
			shader="Skyscreen/Manifold5_wakeboard3TpRail",--wakeboard3TpRail.shader", --This shader will work as a skyscreen (rendered to a quad), but works better when it gets depth information from world-space geometry like this rail
			skyScreen_FixedTrackOffset = {4.47,-20.32,0}
		}
	end


	Profile("wakeboard rails")
	
end

]]--


Profile("stub")
if math.random(4)==1 then
	CreateRepeatedMeshRail{
		ahead_renderdist = 1500,
		behind_renderdist = 20,
		spacing = 1, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
		colorMode = "none", --"highway" --"highwayinverted"

		buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
		maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
		calculatenormals = false, --set true if using lighting
		
		gameobject={
		transform={pos={0,0,-5},scale={.8,.8,.8}},
			name="meshrailproto1",
			shadowcaster = false,
			shadowreceiver = false,
			mesh="tiki.obj",
			--transform={pos={0,0,-5},scale={x=1.2,y=10,z=1.2}},
			
			layer=13,
			shader="VertexColorUnlitTinted",
			shadercolors={
				_Color={r=169,g=109,b=0}
			},
			texture="wood.png"
		}
	}
end


CreateRail{--big cliff
	positionOffset={
		x=0,
		y=0},
	crossSectionShape={
		{x=trackWidth+8,y=-2},
		{x=trackWidth+8,y=-80},
		{x=-trackWidth-8,y=-80},
		{x=-trackWidth-8,y=-2},
		--{x=-trackWidth,y=0},
		--{x=trackWidth,y=0},
		},
	perShapeNodeColorScalers={
		1,
		1,
		--2,
		--2,
		1,
		1,
		1
		},
	color = {r=144,g=104,b=48},
	flatten=false,
	wrapnodeshape = true,
	texture="cliffRails.png",
	fullfuture = true,--ifhifi(true,false),
	stretch = 1,
	--nodeskip = bridgeinterval,
	calculatenormals = true,
	shader="VertexColorUnlitTinted"
}


CreateRail{--road surface
	positionOffset={
		x=0,
		y=0},
	crossSectionShape={
		{x=trackWidth+4,y=0},
		--{x=-trackWidth-5,y=-30},
		{x=trackWidth+8.5,y=-2},
		{x=trackWidth+8.5,y=-5},
		{x=-trackWidth-8.5,y=-5},
		--{x=trackWidth-5,y=-30},
		{x=-trackWidth-8.5,y=-2},
		{x=-trackWidth-4,y=0}
		},
	perShapeNodeColorScalers={
		1,
		--1,
		2,
		2,
		--1,
		1
		},
	color = {r=0,g=255,b=0},
	flatten=false,
	--fullfuture = true,--ifhifi(true,false),
	--stretch = 1,
	--nodeskip = bridgeinterval,
	texture = "ground1.png",
	texture = table.concat({"ground", math.random(4), ".png"}, ""),
	shader = "VertexColorLitTinted",
}

--[[
if not jumping then
	CreateRail{--shadow catcher to make it look like shadows are landing on the road
		positionOffset={
			x=0,
			y=0},
		crossSectionShape={
			{x=-trackWidth-9.0,y=0.25},
			{x=trackWidth+9.0,y=0.25}},
		colorMode="static",
		layer=14,--renders only close to the camera, but renders over the top of most other things
		color = {r=0,g=0,b=0,a=0},
		flatten=false,
		shadowreceiver = true,
		shadowcaster = false,
		--texture="cliffRails.png",
		shader="TransparentShadowReceiver"
	}

	CreateRail{--subroad center
		positionOffset={
			x=0,
			y=0},
		crossSectionShape={
			{x=-1.5,y=0},
			{x=1.5,y=0}},
		colorMode="static",
		layer=13,
		wrapnodeshape = false,
		fullfuture = true,
		color = {r=255,g=255,b=255,a=255},
		flatten=false,
		renderqueue=3001,
		--texture="subroad.png",
		shader="VertexColorUnlitTintedAlpha",
		shadercolors={_Color={r=30,g=30,b=30,a=245}}
	}

	CreateRail{--subroad left
		positionOffset={
			x=0,
			y=0},
		crossSectionShape={
			{x=-4.5-extraWidth,y=0},
			{x=-1.5,y=0}},
		colorMode="static",
		layer=13,
		wrapnodeshape = false,
		fullfuture = true,
		color = {r=255,g=255,b=255,a=255},
		flatten=false,
		renderqueue=3001,
		--texture="subroad.png",
		shader="VertexColorUnlitTintedAlpha",
		shadercolors={_Color={r=47,g=45,b=43,a=180}}
	}

	CreateRail{--subroad right
		positionOffset={
			x=0,
			y=0},
		crossSectionShape={
			{x=1.5,y=0},
			{x=4.5+extraWidth,y=0}},
		colorMode="static",
		layer=13,
		wrapnodeshape = false,
		fullfuture = true,
		color = {r=255,g=255,b=255,a=255},
		flatten=false,
		renderqueue=3001,
		--texture="subroad.png",
		shader="VertexColorUnlitTintedAlpha",
		shadercolors={_Color={r=47,g=45,b=43,a=180}}
	}

	CreateRail{--rollercoaster horizontal support
		positionOffset={
			x=0,
			y=-33},
		crossSectionShape={
			{x=-1.5,y=1.5},
			{x=1.5,y=1.5},
			{x=1.5,y=-4.5},
			{x=-1.5,y=-4.5}},
		perShapeNodeColorScalers={
			1,
			1,
			1,
			1},
		colorMode="highway",
		color = {r=255,g=255,b=255},
		flatten=false,
		fullfuture = true,
		texture="White.png",
		shader="VertexColorUnlitTintedAdd"
	}

	CreateRail{--rollercoaster overhead rail
		positionOffset={
			x=0,
			y=22},
		crossSectionShape={
			{x=-1.5,y=1.5},
			{x=1.5,y=1.5},
			{x=1.5,y=-1.5},
			{x=-1.5,y=-1.5}},
		perShapeNodeColorScalers={
			1,
			1,
			1,
			1},
		colorMode="highway",
		color = {r=255,g=255,b=255},
		flatten=false,
		fullfuture = true,
		texture="White.png",
		shader="VertexColorUnlitTintedAdd"
	}



		CreateRail{--left aurora core
			positionOffset={
				x=-5.3-extraWidth,
				y=5.2},
			crossSectionShape={
				{x=-.99,y=.5},
				{x=0.5,y=.5},
				{x=0.5,y=.2},
				{x=-0.99,y=.2}},
			perShapeNodeColorScalers={
				1,
				1,
				1,
				1},
			colorMode="highway",
			renderqueue=3000,
			color = {r=127,g=127,b=127},
			flatten=false,
			texture="White.png",
			shader="VertexColorUnlitTintedAdd"
		}

		CreateRail{--right aurora core
			positionOffset={
				x=5.3+extraWidth,
				y=5.2},
			crossSectionShape={
				{x=-.5,y=.5},
				{x=.99,y=.5},
				{x=.99,y=.2},
				{x=-.5,y=.2}},
			perShapeNodeColorScalers={
				1,
				1,
				1,
				1},
			colorMode="highway",
			renderqueue=3000,
			color = {r=127,g=127,b=127},
			flatten=false,
			texture="White.png",
			shader="VertexColorUnlitTintedAdd"
		}



		CreateRail{--left aurora core lower
			positionOffset={
				x=-5.1-extraWidth,
				y=2.0},
			crossSectionShape={
				{x=-.99,y=.5},
				{x=0.5,y=.5},
				{x=0.5,y=.3},
				{x=-0.99,y=.3}},
			perShapeNodeColorScalers={
				1,
				1,
				1,
				1},
			colorMode="highway",
			renderqueue=3000,
			color = {r=127,g=127,b=127},
			flatten=false,
			texture="White.png",
			shader="VertexColorUnlitTintedAdd"
		}

		CreateRail{--right aurora core lower
			positionOffset={
				x=5.1+extraWidth,
				y=2.0},
			crossSectionShape={
				{x=-.5,y=.5},
				{x=.99,y=.5},
				{x=.99,y=.3},
				{x=-.5,y=.3}},
			perShapeNodeColorScalers={
				1,
				1,
				1,
				1},
			colorMode="highway",
			renderqueue=3000,
			color = {r=127,g=127,b=127},
			flatten=false,
			texture="White.png",
			shader="VertexColorUnlitTintedAdd"
		}		





	auroraExtent = ifhifi(44, 22)
	auroraHeight = auroraExtent / 1.75
	CreateRail{--left aurora
		positionOffset={
			x=-5-extraWidth,
			y=5},
		crossSectionShape={
			{x=-auroraExtent,y=auroraHeight},
			{x=0,y=.5},
			{x=0,y=-.5},
			{x=-auroraExtent,y=auroraHeight-1}},
		perShapeNodeColorScalers={
			0,
			1,
			1,
			0},
		colorMode="aurora",
		color = {r=255,g=255,b=255},
		flatten=false,
	    layer=13,
	    renderqueue=3000,
		texture="White.png",
		shader="VertexColorUnlitTintedAddDouble"
	}

	CreateRail{--right aurora
		positionOffset={
			x=5+extraWidth,
			y=5},
		crossSectionShape={
			{x=0,y=.5},
			{x=auroraExtent,y=auroraHeight},
			{x=auroraExtent,y=auroraHeight-1},
			{x=0,y=-.5}},
		perShapeNodeColorScalers={
			1,
			0,
			0,
			1},
		colorMode="aurora",
		color = {r=255,g=255,b=255},
		flatten=false,
	    layer=13,
		texture="White.png",
		renderqueue=3000,
		shader="VertexColorUnlitTintedAddDouble"
	}
else
	CreateRail{--left aurora core
		positionOffset={
			x=-22.08,
			y=4.68},
		crossSectionShape={
			{x=-0.5,y=-0.5},
			{x=-0.5,y=.5},
			{x=.1,y=.5},
			{x=0.1,y=-0.5}},
		perShapeNodeColorScalers={
			0,
			1.5,
			0.5,
			0},
		colorMode="highway",
		color = {r=0,g=0,b=0},
		flatten=false,
		--texture="fadedRailTop.png",
		--perShapeNodeColorScalersScaleAlpha = false,
		--textureMode = "wraparound",
		texture="White.png",
		shader="Diffuse"
	}

	CreateRail{--right aurora core
		positionOffset={
			x=22.08,
			y=4.68},
		crossSectionShape={
			{x=-0.1,y=-0.5},
			{x=-.1,y=.5},
			{x=0.5,y=.5},
			{x=0.5,y=-0.5}
			},
		perShapeNodeColorScalers={
			0,
			0.5,
			3.5,
			0},
		colorMode="highway",
		color = {r=0,g=0,b=0},
		flatten=false,
		--texture="fadedRailTop.png",
		--perShapeNodeColorScalersScaleAlpha=false,
		--textureMode = "wraparound",
		texture="White.png",
		shader="Diffuse"
	}

	CreateRail{--left aurora core
		positionOffset={
			x=-16.45,
			y=20.574},
		crossSectionShape={
			{x=-.1,y=.1},
			{x=0.1,y=.1},
			{x=0.1,y=-.1},
			{x=-0.1,y=-.1}},
		perShapeNodeColorScalers={
			1,
			1,
			1,
			1},
		colorMode="highway",
		color = {r=255,g=255,b=255},
		flatten=false,
		texture="White.png",
		shader="VertexColorUnlitTintedAdd"
	}

	CreateRail{--right aurora core
		positionOffset={
			x=16.45,
			y=20.574},
		crossSectionShape={
			{x=-.1,y=.1},
			{x=.1,y=.1},
			{x=.1,y=-.1},
			{x=-.1,y=-.1}},
		perShapeNodeColorScalers={
			1,
			1,
			1,
			1},
		colorMode="highway",
		color = {r=255,g=255,b=255},
		flatten=false,
		texture="White.png",
		shader="VertexColorUnlitTintedAdd"
	}

	auroraExtent = ifhifi(44, 22)
	auroraHeight = -1.0 * (auroraExtent / 1.75)
	CreateRail{--left aurora
		positionOffset={
			x=-16.45,
			y=20.574},
		crossSectionShape={
			{x=-auroraExtent,y=auroraHeight},
			{x=0,y=.5},
			{x=0,y=-.5},
			{x=-auroraExtent,y=auroraHeight-1}},
		perShapeNodeColorScalers={
			0,
			1,
			1,
			0},
		colorMode="aurora",
		color = {r=255,g=255,b=255},
		flatten=false,
	    layer=13,
	    renderqueue=3000,
		texture="White.png",
		shader="VertexColorUnlitTintedAddDouble"
	}

	CreateRail{--right aurora
		positionOffset={
			x=16.45,
			y=20.574},
		crossSectionShape={
			{x=0,y=.5},
			{x=auroraExtent,y=auroraHeight},
			{x=auroraExtent,y=auroraHeight-1},
			{x=0,y=-.5}},
		perShapeNodeColorScalers={
			1,
			0,
			0,
			1},
		colorMode="aurora",
		color = {r=255,g=255,b=255},
		flatten=false,
	    layer=13,
		texture="White.png",
		renderqueue=3000,
		shader="VertexColorUnlitTintedAddDouble"
	}	
end
]]--
Profile("road and aurora")